program wbzip_new;{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  Windows,
  Inifiles,
  SZCodeBaseX in 'SZCodeBaseX.pas',
  StrUtils,
  Encode in 'Encode.pas',
  Decode in 'Decode.pas',
  OOCodeBaseX in 'OOCodeBaseX.pas',
  PerformanceCounter in 'PerformanceCounter.pas',
  OutputStreams in 'OutputStreams.pas',
  ZLibArchive2 in 'ZLibArchive2\ZLibArchive2.pas',
  ZLIBEX in 'ZLibArchive2\ZLIBEX.PAS',
  ZLIBArchiveGlobals2 in 'ZLibArchive2\ZLIBArchiveGlobals2.pas',
  ZLibArchive2Light in 'ZLibArchive2Light.pas';

var
  s: string;
begin
  if paramcount = 0 then
  begin
    writeln('');
    writeln('WBzip - Encode and decode binary files on .script files');
    writeln('');
    writeln('    -x  Extract files from script');
    writeln('    -a  Add files to script');
    writeln('');
    writeln('Syntax:');
    writeln('');
    writeln('  wbzip.exe -x ScriptFile Section File OutputPath');
    writeln('  wbzip.exe -a ScriptFile Section File(s)');
    writeln('');
    writeln('version 1.2  [2007-08-29]');
    writeln('optimized for speed by booty#1');
    writeln('');
    writeln('< press any key to continue.. >');
    ReadLn(s);
    exit;
  end;

  //wbzip -a script section file
  //wbzip -x script section file OutputPath


  s := AnsiLowerCase(ParamStr(1));

  if s = '-x' then
  begin
    try
    if Internal_ExtractFileToDisk(ParamStr(2), ParamStr(3), ParamStr(4),
      ParamStr(5),false) then
      s := 'Sucessfully extracted from script: [' + ParamStr(2) +
        '] section: [' + ParamStr(3) + '] file: [' + ParamStr(4) +
        '] To path: [' + ParamStr(5) + ']'
    else
      s := 'Failed to extract from script: [' + ParamStr(2) +
        '] section: [' + ParamStr(3) + '] file: [' + ParamStr(4) +
        '] To path: [' + ParamStr(5) + ']';
    writeln(s);
    except
      writeln('< press any key to continue.. >');
    end;
  end;

  //Encode(SourceFile, ScriptFile, InternalGroup : String):Boolean;
  //wbzip -a script section file
  //       1    2      3      4

  if s = '-a' then
  begin
    if Internal_FileEncode(ParamStr(4), ParamStr(2), ParamStr(3)) then
      s := 'Sucessfully encoded on file: [' + ParamStr(2) + '] section: [' +
        ParamStr(3) + '] file: [' + ParamStr(4) + ']'
    else
      s := 'Failed to encode on file: [' + ParamStr(2) + '] section: [' +
        ParamStr(3) + '] file: [' + ParamStr(4) + ']';
    writeln(s);
  end;

  {$IFDEF PerformanceCounter}
  Writeln('');
  Writeln('---------------------------------------');
  Writeln('Performace data measurements:');
  Writeln('');
  Writeln(PC.toString);
  ReadLn(s);
  {$ENDIF}
end.
